#ifndef _H_AA4801B5FB7488A91B0AD4E5B2A1C10A_DifferentialMeasurement__H_
#define _H_AA4801B5FB7488A91B0AD4E5B2A1C10A_DifferentialMeasurement__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_.h"


namespace marti_sensor_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  DifferentialMeasurement_
            {
                struct _position_covariance__uniq_{};
                typedef ::DDS::Double _position_covariance__slice;
                typedef ::DDS::Double _position_covariance_[9];
                typedef DDS_DCPS_FArray_var< _position_covariance_, _position_covariance__slice, struct _position_covariance__uniq_ > _position_covariance__var;
                typedef _position_covariance_ _position_covariance__out;
                typedef DDS_DCPS_Array_forany< _position_covariance_, _position_covariance__slice, struct _position_covariance__uniq_ > _position_covariance__forany;
                static _position_covariance__slice *_position_covariance__alloc();
                static void _position_covariance__free(_position_covariance__slice *);
                static void _position_covariance__copy(_position_covariance__slice *to, const _position_covariance__slice *from);
                static _position_covariance__slice *_position_covariance__dup(const _position_covariance__slice *from);
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::String_mgr base_frame_id_;
                ::DDS::Double baseline_length_;
                ::DDS::Double baseline_length_variance_;
                ::DDS::Double heading_;
                ::DDS::Double heading_variance_;
                ::DDS::Double pitch_;
                ::DDS::Double pitch_variance_;
                ::DDS::Double roll_;
                ::DDS::Double roll_variance_;
                ::geometry_msgs::msg::dds_::Vector3_ position_;
                _position_covariance_ position_covariance_;
            };

            typedef DDS_DCPSStruct_var<DifferentialMeasurement_> DifferentialMeasurement__var;
            typedef DDS_DCPSStruct_out < DifferentialMeasurement_> DifferentialMeasurement__out;

        }

    }

}

#endif /* _H_AA4801B5FB7488A91B0AD4E5B2A1C10A_DifferentialMeasurement__H_ */
