#ifndef _H_AA4801B5FB7488A91B0AD4E5B2A1C10A_DifferentialMeasurement_DCPS_H_
#define _H_AA4801B5FB7488A91B0AD4E5B2A1C10A_DifferentialMeasurement_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DifferentialMeasurement_.h"


namespace marti_sensor_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DifferentialMeasurement_TypeSupportInterface;

            typedef DifferentialMeasurement_TypeSupportInterface * DifferentialMeasurement_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DifferentialMeasurement_TypeSupportInterface> DifferentialMeasurement_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DifferentialMeasurement_TypeSupportInterface> DifferentialMeasurement_TypeSupportInterface_out;


            class DifferentialMeasurement_DataWriter;

            typedef DifferentialMeasurement_DataWriter * DifferentialMeasurement_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DifferentialMeasurement_DataWriter> DifferentialMeasurement_DataWriter_var;
            typedef DDS_DCPSInterface_out < DifferentialMeasurement_DataWriter> DifferentialMeasurement_DataWriter_out;


            class DifferentialMeasurement_DataReader;

            typedef DifferentialMeasurement_DataReader * DifferentialMeasurement_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DifferentialMeasurement_DataReader> DifferentialMeasurement_DataReader_var;
            typedef DDS_DCPSInterface_out < DifferentialMeasurement_DataReader> DifferentialMeasurement_DataReader_out;


            class DifferentialMeasurement_DataReaderView;

            typedef DifferentialMeasurement_DataReaderView * DifferentialMeasurement_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DifferentialMeasurement_DataReaderView> DifferentialMeasurement_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DifferentialMeasurement_DataReaderView> DifferentialMeasurement_DataReaderView_out;

            struct DifferentialMeasurement_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DifferentialMeasurement_, struct DifferentialMeasurement_Seq_uniq_> DifferentialMeasurement_Seq;
            typedef DDS_DCPSSequence_var < DifferentialMeasurement_Seq> DifferentialMeasurement_Seq_var;
            typedef DDS_DCPSSequence_out < DifferentialMeasurement_Seq> DifferentialMeasurement_Seq_out;

            class  DifferentialMeasurement_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DifferentialMeasurement_TypeSupportInterface_ptr _ptr_type;
                typedef DifferentialMeasurement_TypeSupportInterface_var _var_type;

                static DifferentialMeasurement_TypeSupportInterface_ptr _duplicate (DifferentialMeasurement_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialMeasurement_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialMeasurement_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DifferentialMeasurement_TypeSupportInterface () {};
                ~DifferentialMeasurement_TypeSupportInterface () {};
            private:
                DifferentialMeasurement_TypeSupportInterface (const DifferentialMeasurement_TypeSupportInterface &);
                DifferentialMeasurement_TypeSupportInterface & operator = (const DifferentialMeasurement_TypeSupportInterface &);
            };

            class  DifferentialMeasurement_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DifferentialMeasurement_DataWriter_ptr _ptr_type;
                typedef DifferentialMeasurement_DataWriter_var _var_type;

                static DifferentialMeasurement_DataWriter_ptr _duplicate (DifferentialMeasurement_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialMeasurement_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialMeasurement_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DifferentialMeasurement_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DifferentialMeasurement_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DifferentialMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DifferentialMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DifferentialMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DifferentialMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DifferentialMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DifferentialMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DifferentialMeasurement_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DifferentialMeasurement_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DifferentialMeasurement_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DifferentialMeasurement_& instance_data) = 0;

            protected:
                DifferentialMeasurement_DataWriter () {};
                ~DifferentialMeasurement_DataWriter () {};
            private:
                DifferentialMeasurement_DataWriter (const DifferentialMeasurement_DataWriter &);
                DifferentialMeasurement_DataWriter & operator = (const DifferentialMeasurement_DataWriter &);
            };

            class  DifferentialMeasurement_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DifferentialMeasurement_DataReader_ptr _ptr_type;
                typedef DifferentialMeasurement_DataReader_var _var_type;

                static DifferentialMeasurement_DataReader_ptr _duplicate (DifferentialMeasurement_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialMeasurement_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialMeasurement_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DifferentialMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DifferentialMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DifferentialMeasurement_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DifferentialMeasurement_& instance) = 0;

            protected:
                DifferentialMeasurement_DataReader () {};
                ~DifferentialMeasurement_DataReader () {};
            private:
                DifferentialMeasurement_DataReader (const DifferentialMeasurement_DataReader &);
                DifferentialMeasurement_DataReader & operator = (const DifferentialMeasurement_DataReader &);
            };

            class  DifferentialMeasurement_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DifferentialMeasurement_DataReaderView_ptr _ptr_type;
                typedef DifferentialMeasurement_DataReaderView_var _var_type;

                static DifferentialMeasurement_DataReaderView_ptr _duplicate (DifferentialMeasurement_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DifferentialMeasurement_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DifferentialMeasurement_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DifferentialMeasurement_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DifferentialMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DifferentialMeasurement_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DifferentialMeasurement_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DifferentialMeasurement_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DifferentialMeasurement_& instance) = 0;

            protected:
                DifferentialMeasurement_DataReaderView () {};
                ~DifferentialMeasurement_DataReaderView () {};
            private:
                DifferentialMeasurement_DataReaderView (const DifferentialMeasurement_DataReaderView &);
                DifferentialMeasurement_DataReaderView & operator = (const DifferentialMeasurement_DataReaderView &);
            };
        }

    }

}

#endif
