#ifndef H_AA4801B5FB7488A91B0AD4E5B2A1C10A_DifferentialMeasurement_SPLTYPES_H
#define H_AA4801B5FB7488A91B0AD4E5B2A1C10A_DifferentialMeasurement_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_DifferentialMeasurement_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_SplDcps.h"



extern c_metaObject __DifferentialMeasurement__marti_sensor_msgs__load (c_base base);

extern c_metaObject __DifferentialMeasurement__marti_sensor_msgs_msg__load (c_base base);

extern c_metaObject __DifferentialMeasurement__marti_sensor_msgs_msg_dds___load (c_base base);

extern const char *marti_sensor_msgs_msg_dds__DifferentialMeasurement__metaDescriptor[];
extern const int marti_sensor_msgs_msg_dds__DifferentialMeasurement__metaDescriptorArrLength;
extern const int marti_sensor_msgs_msg_dds__DifferentialMeasurement__metaDescriptorLength;
extern c_metaObject __marti_sensor_msgs_msg_dds__DifferentialMeasurement___load (c_base base);
struct _marti_sensor_msgs_msg_dds__DifferentialMeasurement_ ;
extern  v_copyin_result __marti_sensor_msgs_msg_dds__DifferentialMeasurement___copyIn(c_base base, const struct marti_sensor_msgs::msg::dds_::DifferentialMeasurement_ *from, struct _marti_sensor_msgs_msg_dds__DifferentialMeasurement_ *to);
extern  void __marti_sensor_msgs_msg_dds__DifferentialMeasurement___copyOut(const void *_from, void *_to);
struct _marti_sensor_msgs_msg_dds__DifferentialMeasurement_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_string base_frame_id_;
    c_double baseline_length_;
    c_double baseline_length_variance_;
    c_double heading_;
    c_double heading_variance_;
    c_double pitch_;
    c_double pitch_variance_;
    c_double roll_;
    c_double roll_variance_;
    struct _geometry_msgs_msg_dds__Vector3_ position_;
    c_double position_covariance_[9];
};

#undef OS_API
#endif
