#ifndef _H_75A32DD778E20AD9A1C7A4F746569CBA_DioRealTimeData_DCPS_H_
#define _H_75A32DD778E20AD9A1C7A4F746569CBA_DioRealTimeData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DioRealTimeData_.h"


namespace marti_sensor_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DioRealTimeData_TypeSupportInterface;

            typedef DioRealTimeData_TypeSupportInterface * DioRealTimeData_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DioRealTimeData_TypeSupportInterface> DioRealTimeData_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DioRealTimeData_TypeSupportInterface> DioRealTimeData_TypeSupportInterface_out;


            class DioRealTimeData_DataWriter;

            typedef DioRealTimeData_DataWriter * DioRealTimeData_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DioRealTimeData_DataWriter> DioRealTimeData_DataWriter_var;
            typedef DDS_DCPSInterface_out < DioRealTimeData_DataWriter> DioRealTimeData_DataWriter_out;


            class DioRealTimeData_DataReader;

            typedef DioRealTimeData_DataReader * DioRealTimeData_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DioRealTimeData_DataReader> DioRealTimeData_DataReader_var;
            typedef DDS_DCPSInterface_out < DioRealTimeData_DataReader> DioRealTimeData_DataReader_out;


            class DioRealTimeData_DataReaderView;

            typedef DioRealTimeData_DataReaderView * DioRealTimeData_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DioRealTimeData_DataReaderView> DioRealTimeData_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DioRealTimeData_DataReaderView> DioRealTimeData_DataReaderView_out;

            struct DioRealTimeData_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DioRealTimeData_, struct DioRealTimeData_Seq_uniq_> DioRealTimeData_Seq;
            typedef DDS_DCPSSequence_var < DioRealTimeData_Seq> DioRealTimeData_Seq_var;
            typedef DDS_DCPSSequence_out < DioRealTimeData_Seq> DioRealTimeData_Seq_out;

            class  DioRealTimeData_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DioRealTimeData_TypeSupportInterface_ptr _ptr_type;
                typedef DioRealTimeData_TypeSupportInterface_var _var_type;

                static DioRealTimeData_TypeSupportInterface_ptr _duplicate (DioRealTimeData_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DioRealTimeData_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DioRealTimeData_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DioRealTimeData_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DioRealTimeData_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DioRealTimeData_TypeSupportInterface () {};
                ~DioRealTimeData_TypeSupportInterface () {};
            private:
                DioRealTimeData_TypeSupportInterface (const DioRealTimeData_TypeSupportInterface &);
                DioRealTimeData_TypeSupportInterface & operator = (const DioRealTimeData_TypeSupportInterface &);
            };

            class  DioRealTimeData_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DioRealTimeData_DataWriter_ptr _ptr_type;
                typedef DioRealTimeData_DataWriter_var _var_type;

                static DioRealTimeData_DataWriter_ptr _duplicate (DioRealTimeData_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DioRealTimeData_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DioRealTimeData_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DioRealTimeData_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DioRealTimeData_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DioRealTimeData_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DioRealTimeData_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DioRealTimeData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DioRealTimeData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DioRealTimeData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DioRealTimeData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DioRealTimeData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DioRealTimeData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DioRealTimeData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DioRealTimeData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DioRealTimeData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DioRealTimeData_& instance_data) = 0;

            protected:
                DioRealTimeData_DataWriter () {};
                ~DioRealTimeData_DataWriter () {};
            private:
                DioRealTimeData_DataWriter (const DioRealTimeData_DataWriter &);
                DioRealTimeData_DataWriter & operator = (const DioRealTimeData_DataWriter &);
            };

            class  DioRealTimeData_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DioRealTimeData_DataReader_ptr _ptr_type;
                typedef DioRealTimeData_DataReader_var _var_type;

                static DioRealTimeData_DataReader_ptr _duplicate (DioRealTimeData_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DioRealTimeData_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DioRealTimeData_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DioRealTimeData_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DioRealTimeData_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DioRealTimeData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DioRealTimeData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DioRealTimeData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DioRealTimeData_& instance) = 0;

            protected:
                DioRealTimeData_DataReader () {};
                ~DioRealTimeData_DataReader () {};
            private:
                DioRealTimeData_DataReader (const DioRealTimeData_DataReader &);
                DioRealTimeData_DataReader & operator = (const DioRealTimeData_DataReader &);
            };

            class  DioRealTimeData_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DioRealTimeData_DataReaderView_ptr _ptr_type;
                typedef DioRealTimeData_DataReaderView_var _var_type;

                static DioRealTimeData_DataReaderView_ptr _duplicate (DioRealTimeData_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DioRealTimeData_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DioRealTimeData_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DioRealTimeData_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DioRealTimeData_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DioRealTimeData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DioRealTimeData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DioRealTimeData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DioRealTimeData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DioRealTimeData_& instance) = 0;

            protected:
                DioRealTimeData_DataReaderView () {};
                ~DioRealTimeData_DataReaderView () {};
            private:
                DioRealTimeData_DataReaderView (const DioRealTimeData_DataReaderView &);
                DioRealTimeData_DataReaderView & operator = (const DioRealTimeData_DataReaderView &);
            };
        }

    }

}

#endif
