#ifndef _H_2E0BAE01191F267C3FF6006AEBA1D5B3_Direction__H_
#define _H_2E0BAE01191F267C3FF6006AEBA1D5B3_Direction__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace marti_sensor_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Direction_Constants
            {
                const ::DDS::Octet BACKWARD_ = 255;

                const ::DDS::Octet ZERO_ = 0;

                const ::DDS::Octet FORWARD_ = 1;

                const ::DDS::Octet UNKNOWN_ = 127;

            }

            struct  Direction_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet direction_;
            };

            typedef DDS_DCPSStruct_var<Direction_> Direction__var;
            typedef DDS_DCPSStruct_out < Direction_> Direction__out;

        }

    }

}

#endif /* _H_2E0BAE01191F267C3FF6006AEBA1D5B3_Direction__H_ */
