#ifndef _H_B7EBC4A643D85C33FC35323610C33003_WheelEncoderSet_DCPS_H_
#define _H_B7EBC4A643D85C33FC35323610C33003_WheelEncoderSet_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WheelEncoderSet_.h"


namespace marti_sensor_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WheelEncoderSet_TypeSupportInterface;

            typedef WheelEncoderSet_TypeSupportInterface * WheelEncoderSet_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WheelEncoderSet_TypeSupportInterface> WheelEncoderSet_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WheelEncoderSet_TypeSupportInterface> WheelEncoderSet_TypeSupportInterface_out;


            class WheelEncoderSet_DataWriter;

            typedef WheelEncoderSet_DataWriter * WheelEncoderSet_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WheelEncoderSet_DataWriter> WheelEncoderSet_DataWriter_var;
            typedef DDS_DCPSInterface_out < WheelEncoderSet_DataWriter> WheelEncoderSet_DataWriter_out;


            class WheelEncoderSet_DataReader;

            typedef WheelEncoderSet_DataReader * WheelEncoderSet_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WheelEncoderSet_DataReader> WheelEncoderSet_DataReader_var;
            typedef DDS_DCPSInterface_out < WheelEncoderSet_DataReader> WheelEncoderSet_DataReader_out;


            class WheelEncoderSet_DataReaderView;

            typedef WheelEncoderSet_DataReaderView * WheelEncoderSet_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WheelEncoderSet_DataReaderView> WheelEncoderSet_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WheelEncoderSet_DataReaderView> WheelEncoderSet_DataReaderView_out;

            struct WheelEncoderSet_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < WheelEncoderSet_, struct WheelEncoderSet_Seq_uniq_> WheelEncoderSet_Seq;
            typedef DDS_DCPSSequence_var < WheelEncoderSet_Seq> WheelEncoderSet_Seq_var;
            typedef DDS_DCPSSequence_out < WheelEncoderSet_Seq> WheelEncoderSet_Seq_out;

            class  WheelEncoderSet_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WheelEncoderSet_TypeSupportInterface_ptr _ptr_type;
                typedef WheelEncoderSet_TypeSupportInterface_var _var_type;

                static WheelEncoderSet_TypeSupportInterface_ptr _duplicate (WheelEncoderSet_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelEncoderSet_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelEncoderSet_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WheelEncoderSet_TypeSupportInterface () {};
                ~WheelEncoderSet_TypeSupportInterface () {};
            private:
                WheelEncoderSet_TypeSupportInterface (const WheelEncoderSet_TypeSupportInterface &);
                WheelEncoderSet_TypeSupportInterface & operator = (const WheelEncoderSet_TypeSupportInterface &);
            };

            class  WheelEncoderSet_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WheelEncoderSet_DataWriter_ptr _ptr_type;
                typedef WheelEncoderSet_DataWriter_var _var_type;

                static WheelEncoderSet_DataWriter_ptr _duplicate (WheelEncoderSet_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelEncoderSet_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelEncoderSet_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WheelEncoderSet_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WheelEncoderSet_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WheelEncoderSet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WheelEncoderSet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WheelEncoderSet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WheelEncoderSet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WheelEncoderSet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WheelEncoderSet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WheelEncoderSet_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WheelEncoderSet_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WheelEncoderSet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelEncoderSet_& instance_data) = 0;

            protected:
                WheelEncoderSet_DataWriter () {};
                ~WheelEncoderSet_DataWriter () {};
            private:
                WheelEncoderSet_DataWriter (const WheelEncoderSet_DataWriter &);
                WheelEncoderSet_DataWriter & operator = (const WheelEncoderSet_DataWriter &);
            };

            class  WheelEncoderSet_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WheelEncoderSet_DataReader_ptr _ptr_type;
                typedef WheelEncoderSet_DataReader_var _var_type;

                static WheelEncoderSet_DataReader_ptr _duplicate (WheelEncoderSet_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelEncoderSet_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelEncoderSet_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelEncoderSet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelEncoderSet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelEncoderSet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelEncoderSet_& instance) = 0;

            protected:
                WheelEncoderSet_DataReader () {};
                ~WheelEncoderSet_DataReader () {};
            private:
                WheelEncoderSet_DataReader (const WheelEncoderSet_DataReader &);
                WheelEncoderSet_DataReader & operator = (const WheelEncoderSet_DataReader &);
            };

            class  WheelEncoderSet_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WheelEncoderSet_DataReaderView_ptr _ptr_type;
                typedef WheelEncoderSet_DataReaderView_var _var_type;

                static WheelEncoderSet_DataReaderView_ptr _duplicate (WheelEncoderSet_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelEncoderSet_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelEncoderSet_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelEncoderSet_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelEncoderSet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelEncoderSet_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelEncoderSet_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelEncoderSet_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelEncoderSet_& instance) = 0;

            protected:
                WheelEncoderSet_DataReaderView () {};
                ~WheelEncoderSet_DataReaderView () {};
            private:
                WheelEncoderSet_DataReaderView (const WheelEncoderSet_DataReaderView &);
                WheelEncoderSet_DataReaderView & operator = (const WheelEncoderSet_DataReaderView &);
            };
        }

    }

}

#endif
