#ifndef _H_02E237220EBAD310A168530FC3D2859D_SetExposure__H_
#define _H_02E237220EBAD310A168530FC3D2859D_SetExposure__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace marti_sensor_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetExposure_Request_
            {
                ::DDS::Boolean auto_exposure_;
                ::DDS::LongLong time_;
            };

            typedef DDS_DCPSStruct_var<SetExposure_Request_> SetExposure_Request__var;
            typedef SetExposure_Request_& SetExposure_Request__out;

            struct  SetExposure_Response_
            {
                ::DDS::Boolean auto_exposure_;
                ::DDS::LongLong time_;
            };

            typedef DDS_DCPSStruct_var<SetExposure_Response_> SetExposure_Response__var;
            typedef SetExposure_Response_& SetExposure_Response__out;

            struct  Sample_SetExposure_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::marti_sensor_msgs::srv::dds_::SetExposure_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetExposure_Request_> Sample_SetExposure_Request__var;
            typedef Sample_SetExposure_Request_& Sample_SetExposure_Request__out;

            struct  Sample_SetExposure_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::marti_sensor_msgs::srv::dds_::SetExposure_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetExposure_Response_> Sample_SetExposure_Response__var;
            typedef Sample_SetExposure_Response_& Sample_SetExposure_Response__out;

        }

    }

}

#endif /* _H_02E237220EBAD310A168530FC3D2859D_SetExposure__H_ */
